Subject: bug#8621: build-aux/compile: avoid race condition failure

From: Peter Rosin <[email-masked]>
Date: Thu, 05 May 2011 21:06:48 +0200

Den 2011-05-05 16:53 skrev Jim Meyering:
> Is there any reason not to make the compile script
> accommodate (in a race-free manner) situations like
> the one described in http://debbugs.gnu.org/8616 ?

Yes, I can think of a couple.  When the compile script
is used to wrap MSVC (aka cl.exe), I think the generated
debug info will point to the actual source file, and if
the source file used to build the executable is gone when
it's time to debug it will be a less than stellar
experience. I imagine this problem to exist for other
toolchains as well? It's also currently not very easy to
override LN_S and MSVC does not understand the symlinks
generated by Cygwin, so symlinking is not a favorite (at
least not for the case where Cygwin is used to drive a
MSVC build).

That said, it's of course better to have any build at all,
even though the debugging experience is not 100% and
the LN_S override trouble can be fixed (and worked around
until it's fixed, IIRC).

I would prefer a solution that doesn't add more pain for
the MSVC case though.

Cheers,
Peter